import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.io.*;
import java.util.*;
import javax.swing.*;
import javax.imageio.*;

/**
 * plNX
 */
public class ARPanel extends JPanel {

	/** L[A_v^[ */
	private		MGKeyAdapter		mgka		= null;

	/** L[ĂԈꗗ */
	private		boolean[]			keyPressTbl	= null;

	/** FDʒu */
	private		int					x			= 0;
	private		int					y			= 0;

	/** x */
	private		int					mx			= 0;

	/** FD */
	private		BufferedImage[]		imageShips	= null;

	/** FĎ */
	private		int					muki		= 0;

	/** ^C}[ */
	private		java.util.Timer		timerThis	= null;

	/** oߎ */
	private		int					time		= 0;

	/**
	 * RXgN^
	 */
	public ARPanel() {

		// X[p[NXĂяo
		super();

		try{

			// plTCY
			super.setPreferredSize(new Dimension(800, 800));
			// CAEgݒ
			super.setLayout(null);

			// L[󋵈ꗗ𐶐
			keyPressTbl = new boolean[256];

			// FDǂݍ
			imageShips = new BufferedImage[3];
			InputStream is0 = this.getClass().getResourceAsStream("imageShip0.gif");
			imageShips[0] = ImageIO.read(is0);
			is0.close();

			InputStream is1 = this.getClass().getResourceAsStream("imageShipR.gif");
			imageShips[1] = ImageIO.read(is1);
			is1.close();

			InputStream is2 = this.getClass().getResourceAsStream("imageShipL.gif");
			imageShips[2] = ImageIO.read(is2);
			is1.close();

			// L[A_v^𐶐
			mgka = new MGKeyAdapter();
			// plɃL[Xi[ǉ
			this.addKeyListener(mgka);

			// 
			init();

			// ^C}[𐶐
			timerThis = new java.util.Timer();

			// ^C}[X^[g
			timerThis.scheduleAtFixedRate(new TimerActionListener(), 1000l, 8l);

		}catch(Exception ex){
			ex.printStackTrace();
			JOptionPane.showMessageDialog(this, "ERROR : " + ex.toString());
		}

	} // end ARPanel

	/**
	 * 
	 */
	public void init(){

		// 
		time = 0;

		// ʒu
		x = 384;
		y = 640;

	} // end init

	/**
	 * s
	 */
	public void run(){

		// ԁ{P
		time++;

		// FDړ^C~O
		if(time % 6 == 0){

			// 
			muki = 0;

			// ̏ꍇA
			if(isKeyCodePressed(KeyEvent.VK_LEFT)){
				// ɂ
				muki = 2;
				// 
				mx = mx - 1;
			}

			// ȄꍇA
			if(isKeyCodePressed(KeyEvent.VK_RIGHT)){
				// ɂ
				muki = 1;
				// 
				mx = mx + 1;
			}

		} // end if FDړ^C~O

		// ړ^C~O
		if(time % 2 == 0){

			// ړ
			x = x + mx;

			// ԍɗꍇA
			if(x < 0){
				x = 0;
				mx = 0;

			// ԉEɗꍇA
			}else if(x > this.getWidth() - 32){
				x = this.getWidth() - 32;
				mx = 0;
			}

		// \^C~O
		}else{

			// ĕ`
			repaint();

		}

	} // end run

	/**
	 * `惁\bh
	 * <pre>
	 * yCgKvƂɂ̃\bhĂяo܂B
	 * </pre>
	 */
	public void paint(Graphics g){

		// ʂhԂ
		g.setColor(Color.black);
		g.fillRect(0, 0, 800, 800);

		// FD`悷
		g.drawImage(imageShips[muki], x, y, 32, 40, this);

	} // end paint

	/**
	 * L[ǂ`FbN
	 */
	public boolean isKeyCodePressed(int keyCode){

		return keyPressTbl[keyCode];

	} // end isKeyCodePressed

	/**
	 * L[A_v^[NX
	 */
	private class MGKeyAdapter extends KeyAdapter {

		/**
		 * L[ƂɌĂ΂܂
		 */
		@Override
		public void keyPressed(KeyEvent ke){
			int code = ke.getKeyCode();
			if(code < 256){
				keyPressTbl[code] = true;
			}
		}

		/**
		 * L[𗣂ƂɌĂ΂܂
		 */
		@Override
		public void keyReleased(KeyEvent ke){
			int code = ke.getKeyCode();
			if(code < 256){
				keyPressTbl[code] = false;
			}
		}

	} // MGKeyAdapter

	/**
	 * ^C}[NX
	 */
	private class TimerActionListener extends TimerTask {

		/**
		 * s
		 */
		@Override
		public void run(){

			// s\bhĂяo
			ARPanel.this.run();

		} // end actionPerformed

	} // end TimerActionListener

}
